﻿using System;
using System.Collections.Generic;
using System.Text;

namespace NTrace
{
    public enum PreprocessorErrors
    {
        /// <summary>
        /// The specified configuration file was not found.
        /// </summary>
        ConfigFileNotFound = 400,
         
        /// <summary>
        /// Unable to load the configuration
        /// </summary>
        CantLoadConfig = 401,

        /// <summary>
        /// there should be at least one argument to the trace method.
        /// </summary>
        InvalidTraceArguments = 500,

        /// <summary>
        /// Invalid expression.
        /// </summary>
        InvalidExpression = 501,
        
        /// <summary>
        /// Invalid level value specified.
        /// </summary>
        InvalidLevelValue = 503,
        
        /// <summary>
        /// Invalid flag enumeration specified.
        /// </summary>
        InvalidFlagEnumeration = 504,
        
        /// <summary>
        /// Invalid flag value specified.
        /// </summary>
        InvalidFlagValue = 505,
        
        /// <summary>
        /// Invalid enumeration specified.
        /// </summary>
        InvalidEnumeration = 506,
        
        /// <summary>
        /// Format string argument index is greater than the number of supplied arguments.
        /// </summary>
        TooManyFormatStringSpecifiers = 508,
        
        /// <summary>
        /// The argument supplied for the format string is not a string.
        /// </summary>
        FormatStringMustBeAString = 509, 
        
        InvalidFileExtension = 600,
    }

}
