﻿using System;

namespace NTrace.Tests
{
  class TraceHelper
  {
    internal static NTrace.ClassicProvider provider;
  }

  class SimpleTest
  {
    static void Main(String[] args)
    {
      EtwTrace.Trace("Howdy!");

      System.Threading.ThreadStart foo = () =>
      {
        EtwTrace.Trace(EtwTraceFlag.Diagnostic, "Lambda support!");
      };

      if (EtwTrace.Enabled)
      {
        // Do something interesting
      }

      if (EtwTrace.TraceFlagEnabled(EtwTraceFlag.Diagnostic))
      {
        // Do something else interesting
      }

      if (EtwTrace.TraceFlagAndLevelEnabled(EtwTraceFlag.Diagnostic, EtwTraceLevel.Information))
      {
        // Do something else interesting
      }
    }

    public static int TestStaticProperty
    {
      get
      {
        EtwTrace.Trace(EtwTraceFlag.Diagnostic, "Property get test.");
      }
      set
      {
        EtwTrace.Trace(EtwTraceFlag.Diagnostic, "Property set test.");
      }
    }

    public int TestInstanceProperty
    {
      get
      {
        EtwTrace.Trace(EtwTraceFlag.Diagnostic, "Property get test.");
      }
      set
      {
        EtwTrace.Trace(EtwTraceFlag.Diagnostic, "Property set test.");
      }
    }

    private void TestLambda()
    {
      Action<int> foo = (i) => { { EtwTrace.Trace("hi"); i++; };
    }
  }
}
