using System;
using System.Collections.Generic;
using System.Text;

namespace NTrace
{
  enum TraceEventErrorCode
  {
    Success = 0,
    /// <summary>
    /// The Flags member of the EVENT_TRACE_HEADER structure is incorrect. 
    /// </summary>
    InvalidFlagNumber = 186,
    /// <summary>
    /// SessionHandle is not valid or specifies the NT Kernel Logger session handle. 
    /// </summary>
    InvalidHandle = 6,
    /// <summary>
    /// The session ran out of free buffers to write to. This can occur during high event rates because the disk subsystem is overloaded or the number of buffers is too small. Rather than blocking until more buffers become available, TraceEvent discards the event.
    /// </summary>
    NotEnoughMemory = 8,
    /// <summary>
    /// The event is discarded because, although the buffer pool has not reached its maximum size, there is insufficient available memory to allocate an additional buffer and there is no buffer available to receive the event.  
    /// </summary>
    OutOfMemory = 14,
    /// <summary>
    /// One of the following is true: SessionHandle is NULL. EventTrace is NULL. The Size member of the EVENT_TRACE_HEADER structure is incorrect. 
    /// </summary>
    InvalidParamter = 87,
    /// <summary>
    /// Data from a single event cannot span multiple buffers. A trace event is limited to the size of the event tracing session's buffer minus the size of the EVENT_TRACE_HEADER structure.  
    /// </summary>
    MoreData = 234,
  }
}
